﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO.Ports;
using System.Collections;
using AsReaderP52N;
using System.Data;

namespace AsReaderP52N_Demo
{
    class Device
    {
        private static AsReader asreader = new AsReaderP52N.AsReader();
        private static AsReaderDelegate asReaderDelegate = new AsReaderP52N.AsReaderDelegate();
        public delegate void WhenSearchedDevices(string ip);
        public static WhenSearchedDevices whenSearchedDevices = null;
        public delegate void WhenReceivedReaderInfo(ReaderInformation readerInfo);
        public static WhenReceivedReaderInfo whenReceivedReaderInfo = null;
        public delegate void WhenReceivedBaseVersion(string version);
        public static WhenReceivedBaseVersion whenReceivedBaseVersion = null;
        public delegate void WhenReceivedSerialParam(int serialParam);
        public static WhenReceivedSerialParam whenReceivedSerialParam = null;
        public delegate void WhenReceivedReaderTime(string readerTime);
        public static WhenReceivedReaderTime whenReceivedReaderTime = null;
        public delegate void WhenReceivedEthernetMac(string ethernetMac);
        public static WhenReceivedEthernetMac whenReceivedEthernetMac = null;
        public delegate void WhenReceivedEthernetIP(EthernetIP ethernetIP);
        public static WhenReceivedEthernetIP whenReceivedEthernetIP = null;
        public delegate void WhenReceivedTcpMode(TcpMode tcpMode);
        public static WhenReceivedTcpMode whenReceivedTcpMode = null;
        public delegate void WhenReceivedTcpHighSpeed(TcpHighSpeed tcpHighSpeed);
        public static WhenReceivedTcpHighSpeed whenReceivedTcpHighSpeed = null;
        public delegate void WhenReceivedRs485Params(Rs485Param rs485Param);
        public static WhenReceivedRs485Params whenReceivedRs485Params = null;
        public delegate void WhenReceivedGPIState(GPIState gpiState);
        public static WhenReceivedGPIState whenReceivedGPIState = null;
        public delegate void WhenReceivedGPITrigger(GPIState gpiState);
        public static WhenReceivedGPITrigger whenReceivedGPITrigger = null;
        public delegate void WhenReceivedGPITriggerParams(GPITriggerParams triggerParams);
        public static WhenReceivedGPITriggerParams whenReceivedGPITriggerParams = null;
        public delegate void WhenReceivedEas(EasInfo eas);
        public static WhenReceivedEas whenReceivedEas = null;
        public delegate void WhenReceivedHeartBeat(byte[] buffer);
        public static WhenReceivedHeartBeat whenReceivedHeartBeat = null;
        public delegate void WhenReceivedSetResult(string setItemName, int resultCode, string ErrMsg);
        public static WhenReceivedSetResult whenReceivedSetResult = null;
        public delegate void WhenReceivedEPCBaseband(EPCBaseband epcBaseband);
        public static WhenReceivedEPCBaseband whenReceivedEPCBaseband = null;
        public delegate void WhenReceivedAntPower(AntPower antPower);
        public static WhenReceivedAntPower whenReceivedAntPower = null;
        public delegate void WhenReceivedFreqRange(int freqRange);
        public static WhenReceivedFreqRange whenReceivedFreqRange = null;
        public delegate void WhenReceivedAutoFree(AutoFree autoFree);
        public static WhenReceivedAutoFree whenReceivedAutoFree = null;
        public delegate void WhenReceivedFilter(Filter filter);
        public static WhenReceivedFilter whenReceivedFilter = null;
        public delegate void WhenReceivedResidenceTime(ResidenceTime residenceTime);
        public static WhenReceivedResidenceTime whenReceivedResidenceTime = null;
        public delegate void WhenReceivedFrequency(Frequency frequency);
        public static WhenReceivedFrequency whenReceivedFrequency = null;
        public delegate void WhenReceivedTag(Tag tag);
        public static WhenReceivedTag whenReceivedTag = null;
        public delegate void WhenReceivedTagReadEnd(Types.ReadEndReasonCode readEndReasonCode);
        public static WhenReceivedTagReadEnd whenReceivedTagReadEnd = null;
        public delegate void WhenReceivedBaseStop(int resultCode, string msg);
        public static WhenReceivedBaseStop whenReceivedBaseStop = null;
        public delegate void WhenReceivedMoistureTag(Tag tag);
        public static WhenReceivedMoistureTag whenReceivedMoistureTag = null;
        public delegate void WhenReceivedMagnusS3Tag(Tag tag);
        public static WhenReceivedMagnusS3Tag whenReceivedMagnusS3Tag = null;
        public delegate void WhenReceivedCRCError();
        public static WhenReceivedCRCError whenReceivedCRCError = null;
        public delegate void WhenDisconnect();
        public static WhenDisconnect whenDisconnect = null;
        public delegate void WhenReceivedData(byte[] data);
        public static WhenReceivedData whenReceivedData = null;
        public delegate void WhenReceivedGBTag(GBTag tag);
        public static WhenReceivedGBTag whenReceivedGBTag = null;
        public delegate void WhenReceivedCommandText(string commandText);
        public static WhenReceivedCommandText whenReceivedCommandText = null;
        public delegate void WhenReceivedTemperatureControl(string currentTemperature);
        public static WhenReceivedTemperatureControl whenReceivedTemperatureControl = null;
        public delegate void WhenReceivedWorkTemperature(WorkTemperature workTemperature);
        public static WhenReceivedWorkTemperature whenReceivedWorkTemperature = null;
        public delegate void WhenReceivedTriggerStart(Types.GPITriggerPorts gpiTriggerPorts, Types.GPOStatus gpoStatus);
        public static WhenReceivedTriggerStart whenReceivedTriggerStart = null;
        public delegate void WhenReceivedTriggerStop(Types.GPITriggerPorts gpiTriggerPorts, Types.GPOStatus gpoStatus);
        public static WhenReceivedTriggerStop whenReceivedTriggerStop = null;
        public static void SetDelegates()
        {
            asReaderDelegate.whenReceivedTriggerStart = (result1, result2) =>
            {
                whenReceivedTriggerStart?.Invoke(result1, result2);
            };
            asReaderDelegate.whenReceivedTriggerStop = (result1, result2) =>
            {
                whenReceivedTriggerStop?.Invoke(result1, result2);
            };
            asReaderDelegate.whenReceivedWorkTemperature = result =>
            {
                whenReceivedWorkTemperature?.Invoke(result);
            };
            asReaderDelegate.whenReceivedTemperatureControl = result =>
            {
                whenReceivedTemperatureControl?.Invoke(result);
            };
            asReaderDelegate.whenReceivedCommandText = (result) =>
            {
                whenReceivedCommandText?.Invoke(result);
            };
            asReaderDelegate.whenReceivedGBTag = (result) =>
            {
                whenReceivedGBTag?.Invoke(result);
            };
            asReaderDelegate.whenReceivedData = (result) =>
            {
                whenReceivedData?.Invoke(result);
            };
            asReaderDelegate.whenDisconnect = () =>
            {
                if (whenDisconnect != null) whenDisconnect();
            };
            asReaderDelegate.whenSearchedDevices = result =>
            {
                if (whenSearchedDevices != null) whenSearchedDevices(result);
            };
            asReaderDelegate.whenReceivedReaderInfo = result =>
            {
                if (whenReceivedReaderInfo != null) whenReceivedReaderInfo(result);
            };
            asReaderDelegate.whenReceivedBaseVersion = result =>
            {
                if (whenReceivedBaseVersion != null) whenReceivedBaseVersion(result);
            };
            asReaderDelegate.whenReceivedSerialParam = result =>
            {
                if (whenReceivedSerialParam != null) whenReceivedSerialParam(result);
            };
            asReaderDelegate.whenReceivedReaderTime = result =>
            {
                if (whenReceivedReaderTime != null) whenReceivedReaderTime(result);
            };
            asReaderDelegate.whenReceivedEthernetMac = result =>
            {
                if (whenReceivedEthernetMac != null) whenReceivedEthernetMac(result);
            };
            asReaderDelegate.whenReceivedEthernetIP = result =>
            {
                if (whenReceivedEthernetIP != null) whenReceivedEthernetIP(result);
            };
            asReaderDelegate.whenReceivedRs485Params = result =>
            {
                if (whenReceivedRs485Params != null) whenReceivedRs485Params(result);
            };
            asReaderDelegate.whenReceivedTcpMode = result =>
            {
                if (whenReceivedTcpMode != null) whenReceivedTcpMode(result);
            };
            asReaderDelegate.whenReceivedTcpHighSpeed = result =>
            {
                if (whenReceivedTcpHighSpeed != null) whenReceivedTcpHighSpeed(result);
            };
            asReaderDelegate.whenReceivedGPIState = result =>
            {
                if (whenReceivedGPIState != null) whenReceivedGPIState(result);
            };
            asReaderDelegate.whenReceivedGPITriggerParams = result =>
            {
                if (whenReceivedGPITriggerParams != null) whenReceivedGPITriggerParams(result);
            };
            asReaderDelegate.whenReceivedEas = result =>
            {
                if (whenReceivedEas != null) whenReceivedEas(result);
            };
            asReaderDelegate.whenReceivedHeartBeat = result =>
            {
                if (whenReceivedHeartBeat != null) whenReceivedHeartBeat(result);
            };
            asReaderDelegate.whenReceivedSetResult = (result1, result2, result3) =>
            {
                if (whenReceivedSetResult != null) whenReceivedSetResult(result1, result2, result3);
            };
            asReaderDelegate.whenReceivedEPCBaseband = result =>
            {
                if (whenReceivedEPCBaseband != null) whenReceivedEPCBaseband(result);
            };
            asReaderDelegate.whenReceivedAntPower = result =>
            {
                if (whenReceivedAntPower != null) whenReceivedAntPower(result);
            };
            asReaderDelegate.whenReceivedFreqRange = result =>
            {
                if (whenReceivedFreqRange != null) whenReceivedFreqRange(result);
            };
            asReaderDelegate.whenReceivedAutoFree = result =>
            {
                if (whenReceivedAutoFree != null) whenReceivedAutoFree(result);
            };
            asReaderDelegate.whenReceivedFilter = result =>
            {
                if (whenReceivedFilter != null) whenReceivedFilter(result);
            };
            asReaderDelegate.whenReceivedResidenceTime = result =>
            {
                if (whenReceivedResidenceTime != null) whenReceivedResidenceTime(result);
            };
            asReaderDelegate.whenReceivedFrequency = result =>
            {
                if (whenReceivedFrequency != null) whenReceivedFrequency(result);
            };
            asReaderDelegate.whenReceivedTag = (result) =>
            {
                if (whenReceivedTag != null) whenReceivedTag(result);
            };
            asReaderDelegate.whenReceivedTagReadEnd = (result) =>
            {
                if (whenReceivedTagReadEnd != null) whenReceivedTagReadEnd(result);
            };
            asReaderDelegate.whenReceivedBaseStop = (result1, reuslt2) =>
            {
                if (whenReceivedBaseStop != null) whenReceivedBaseStop(result1, reuslt2);
            };
            asReaderDelegate.whenReceivedMoistureTag = result =>
            {
                if (whenReceivedMoistureTag != null) whenReceivedMoistureTag(result);
            };
            asReaderDelegate.whenReceivedMagnusS3Tag = result =>
            {
                if (whenReceivedMagnusS3Tag != null) whenReceivedMagnusS3Tag(result);
            };
            asReaderDelegate.whenReceivedCRCError = () =>
            {
                if (whenReceivedCRCError != null) whenReceivedCRCError();
            };
            asreader.SetDelegates(asReaderDelegate);
        }
        public static string[] GetPortNames()
        {
            return asreader.GetPortNames();
        }
        public static UInt32 GetReaderInfo()
        {
            return asreader.GetReaderInfo();
        }
        public static UInt32 GetBaseVersion()
        {
            return asreader.GetBaseVersion();
        }
        public static UInt32 GetSerialParam()
        {
            return asreader.GetSerialParam();
        }
        public static UInt32 SetSerialParam(Types.Baudrate baudrate)
        {
            return asreader.SetSerialParam(baudrate);
        }
        public static UInt32 GetEthernetIP()
        {
            return asreader.GetEthernetIP();
        }
        public static UInt32 SetEthernetIP(EthernetIP ethernetIP)
        {
            return asreader.SetEthernetIP(ethernetIP);
        }
        public static UInt32 GetEthernetMac()
        {
            return asreader.GetEthernetMac();
        }
        public static UInt32 GetTcpMode()
        {
            return asreader.GetTcpMode();
        }
        public static UInt32 SetTcpMode(TcpMode tcpMode)
        {
            return asreader.SetTcpMode(tcpMode);
        }
        public static UInt32 GetReaderTime()
        {
            return asreader.GetReaderTime();
        }
        public static UInt32 SetReaderTime(ReaderTime time)
        {
            return asreader.SetReaderTime(time);
        }
        public static UInt32 GetRs485()
        {
            return asreader.GetRs485();
        }
        public static UInt32 SetRs485(Types.Baudrate baudrate, int address)
        {
            return asreader.SetRs485(baudrate, address);
        }
        //public static UInt32 GetHostName()
        //{
        //    return asreader.GetHostName();
        //}
        //public static UInt32 GetTcpHighSpeed()
        //{
        //    return asreader.GetTcpHighSpeed();
        //}
        public static UInt32 SetGPO(GPO gpo)
        {
            return asreader.SetGPO(gpo);
        }
        public static UInt32 SetBeep(Beep beep)
        {
            return asreader.SetBeep(beep);
        }
        public static UInt32 SetBeepOnOff(int onOff)
        {
            return asreader.SetBeepOnOff(onOff);
        }
        public static UInt32 GetGpiState()
        {
            return asreader.GetGpiState();
        }
        public static UInt32 GetGpiTrigger(Types.GPITriggerPorts triggerPort)
        {
            return asreader.GetGpiTrigger(triggerPort);
        }
        public static UInt32 SetGpiTrigger(GPITriggerParamsSetting gpiTriggerParamsSet)
        {
            return asreader.SetGpiTrigger(gpiTriggerParamsSet);
        }
        public static UInt32 GetEas()
        {
            return asreader.GetEas();
        }
        public static UInt32 SetEas(EasInfo info)
        {
            return asreader.SetEas(info);
        }
        public static UInt32 GetEPCBaseband()
        {
            return asreader.GetEPCBaseband();
        }
        public static UInt32 SetEPCBaseband(EPCBaseband epcBaseband)
        {
            return asreader.SetEPCBaseband(epcBaseband);
        }
        public static UInt32 GetAntPower()
        {
            return asreader.GetAntPower();
        }
        public static UInt32 SetAntPower(AntPower antPower, bool powerDownSave)
        {
            return asreader.SetAntPower(antPower, powerDownSave);
        }
        public static UInt32 GetFreqRange()
        {
            return asreader.GetFreqRange();
        }
        public static UInt32 SetFreqRange(int freqRangeIndex)
        {
            return asreader.SetFreqRange(freqRangeIndex);
        }
        public static UInt32 GetAutoFree()
        {
            return asreader.GetAutoFree();
        }
        public static UInt32 SetAutoFree(AutoFree autoFree)
        {
            return asreader.SetAutoFree(autoFree);
        }
        public static UInt32 GetFilter()
        {
            return asreader.GetFilter();
        }
        public static UInt32 SetFilter(ushort repeatTime, int rssiMax)
        {
            return asreader.SetFilter(repeatTime, rssiMax);
        }
        public static UInt32 GetResidenceTime()
        {
            return asreader.GetResidenceTime();
        }
        public static UInt32 SetResidenceTime(ResidenceTime residenceTime)
        {
            return asreader.SetResidenceTime(residenceTime);
        }
        public static UInt32 GetTemperatureControl()
        {
            return asreader.GetTemperatureControl();
        }
        public static UInt32 SetTemperatureControl(byte onOff, double temperature, byte overrunAction)
        {
            return asreader.SetTemperatureControl(onOff, temperature, overrunAction);
        }
        public static UInt32 GetFrequency()
        {
            return asreader.GetFrequency();
        }
        public static UInt32 SetFrequency(Types.FrequencyAutoFixed frequencyAutoFixed, byte[] pointList, bool powerDownSave)
        {
            return asreader.SetFrequency(frequencyAutoFixed, pointList, powerDownSave);
        }
        public static UInt32 GetGbBaseband()
        {
            return asreader.GetGbBaseband();
        }
        public static UInt32 BaseStop()
        {
            return asreader.BaseStop();
        }
        public static UInt32 BaseRead(ReadParameters baseInventoryEpcSingle)
        {
            return asreader.BaseRead(baseInventoryEpcSingle);
        }
        public static UInt32 BaseInventory(InventoryParameters inventoryParameters)
        {
            return asreader.BaseInventory(inventoryParameters);
        }
        public static UInt32 BaseInventoryGB(InventoryParameters inventoryParameters)
        {
            return asreader.BaseInventoryGB(inventoryParameters);
        }
        public static UInt32 WriteTag(WriteParameters writeParameters)
        {
            return asreader.WriteTag(writeParameters);
        }
        public static UInt32 LockTag(LockParameters lockParameters)
        {
            return asreader.LockTag(lockParameters);
        }
        public static UInt32 KillTag(KillParameters killParameters)
        {
            return asreader.KillTag(killParameters);
        }
        public static UInt32 SendHeartBeatBuffer(byte[] data)
        {
            return asreader.SendHeartBeatBuffer(data);
        }
        public static void StartSearchDevice()
        {
            asreader.StartSearchDevice();
        }
        public static void StopSearchDevice()
        {
            asreader.StopSearchDevice();
        }
        public static UInt32 ConnectServerWithRS232(string comPort, int baudrate)
        {
            UInt32 ret = asreader.ConnectServerWithRS232(comPort, baudrate);
            return ret;
        }
        public static UInt32 ConnectServerWithRS485(string comPort, int baudrate, int address)
        {
            UInt32 ret = asreader.ConnectServerWithRS485(comPort, baudrate, address);
            return ret;
        }
        public static UInt32 ConnectWithTcp(string tcpIpAddress, int tcpPort)
        {
            UInt32 ret = asreader.ConnectWithTCP(tcpIpAddress, tcpPort);
            return ret;
        }

        public static UInt32 CreatTcpServer(string tcpIpAddress, int tcpPort)
        {
            UInt32 ret = asreader.CreatTcpServer(tcpIpAddress, tcpPort);
            return ret;
        }

        public static UInt32 RestoreFactorySettings()
        {
            return asreader.RestoreFactorySettings();
        }
        public static UInt32 Restart()
        {
            return asreader.Restart();
        }
        static byte frameHead = 0x5A;
        static void MakeUpgradeFrame(ref List<byte> list, UInt32 pkgNo, byte[] buffers)
        {
            byte[] pkgNoBuffer = BitConverter.GetBytes(pkgNo);
            byte[] dataLength;
            int datalen = 0;
            if (buffers != null && buffers.Length > 0)
            {
                dataLength = BitConverter.GetBytes((ushort)buffers.Length);
                datalen = buffers.Length;
            }
            else
            {
                dataLength = new byte[] { 0x00, 0x00 };
                datalen = 0;
            }
            byte[] length = BitConverter.GetBytes((ushort)(pkgNoBuffer.Length + dataLength.Length + datalen));
            if (BitConverter.IsLittleEndian)
            {
                Array.Reverse(pkgNoBuffer);
                Array.Reverse(dataLength);
                Array.Reverse(length);
            }
            list.AddRange(length);
            list.AddRange(pkgNoBuffer);
            list.AddRange(dataLength);
            if (buffers != null) list.AddRange(buffers);
            byte[] tmp = list.ToArray();
            byte[] checkCode = BitConverter.GetBytes(CRC16_CCITT(tmp, tmp.Length));
            if (BitConverter.IsLittleEndian) Array.Reverse(checkCode);
            list.AddRange(checkCode);
            list.Insert(0, frameHead);
        }
        public static UInt32 UpgradeApp(UInt32 packageNo, byte[] bufferData, ConnectType connectType, byte rs485Address = 0)
        {
            try
            {
                List<byte> list = new List<byte>();
                if (connectType == ConnectType.RS485)
                {
                    //frameControlProtocol
                    list.AddRange(new byte[] { 0x00, 0x01, 0x24, 0x00 });
                    //frameSerialDeviceMac
                    list.Add(rs485Address);
                }
                else
                {
                    //frameControlProtocol
                    list.AddRange(new byte[] { 0x00, 0x01, 0x04, 0x00 });
                }
                MakeUpgradeFrame(ref list, packageNo, bufferData);
                return asreader.Send(list.ToArray());
            }
            catch (Exception ex)
            {
                Console.WriteLine("UpgradeApp: " + ex.Message);
                return 1;
            }
        }
        public static UInt32 UpgradeBaseband(UInt32 packageNo, byte[] bufferData, ConnectType connectType, byte rs485Address = 0)
        {
            try
            {
                List<byte> list = new List<byte>();
                if (connectType == ConnectType.RS485)
                {
                    //frameControlProtocol
                    list.AddRange(new byte[] { 0x00, 0x01, 0x24, 0x01 });
                    //frameSerialDeviceMac
                    list.Add(rs485Address);
                }
                else
                {
                    //frameControlProtocol
                    list.AddRange(new byte[] { 0x00, 0x01, 0x04, 0x01 });
                }
                MakeUpgradeFrame(ref list, packageNo, bufferData);
                return asreader.Send(list.ToArray());
            }
            catch (Exception ex)
            {
                Console.WriteLine("UpgradeBaseband: " + ex.Message);
                return 1;
            }
        }
        public static UInt32 Disconnect()
        {
            return asreader.Disconnect();
        }
        public static void GetEPCBasebandList(ref List<KeyValuePair<int, string>> epcBasebandList)
        {
            epcBasebandList = new List<KeyValuePair<int, string>>()
            {
                new KeyValuePair<int, string>(0, "0|Tari=25us,FM0,LHF=40KHz"),
                new KeyValuePair<int, string>(1, "1|Dense mode."),
                new KeyValuePair<int, string>(2, "2|Tari=25us,Miller4,LHF=300KHz"),
                new KeyValuePair<int, string>(3, "3|Fast mode."),
                new KeyValuePair<int, string>(4, "4|Tari=20us,Miller2,LHF=320KHz"),
                new KeyValuePair<int, string>(5, "5|Tari=6.25us,FM0,LHF=620KHz"),
                new KeyValuePair<int, string>(6, "6|Tari=20us,Miller4,LHF=320KHz"),
                new KeyValuePair<int, string>(7, "7|Tari=6.25us,Miller4,LHF=400KHz"),
                new KeyValuePair<int, string>(10, "10|Tari=12.5us,Miller4,LHF=250KHz"),
                new KeyValuePair<int, string>(11, "11|Tari=6.25us,Miller4,LHF=250KHz"),
                new KeyValuePair<int, string>(12, "12|Tari=12.5us,Miller4,LHF=300KHz"),
                new KeyValuePair<int, string>(13, "13|Tari=6.25us,Miller4,LHF=300KHz"),
                new KeyValuePair<int, string>(255, "Auto"),
            };
        }
        public static void GetFreqListByFreqPoint(object freqPoint, ref ArrayList fList)
        {
            asreader.GetFreqListByFreqPoint(freqPoint, ref fList);
        }
        public static DataTable getComboxList(Type type)
        {
            string replace = "";
            if (type == typeof(Types.Baudrate) || 
                type == typeof(Types.GPITriggerStartConditions) || 
                type == typeof(Types.FrequencyAutoFixed) ||
                type == typeof(Types.GPITriggerStopConditions))
            {
                replace = "_";
            }
            return MakeList(type, replace);
        }
        static DataTable MakeList(Type type, string replaceChar)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("value", typeof(int));
            dt.Columns.Add("name", Type.GetType("System.String"));
            Array arrs = System.Enum.GetValues(type);// 获取枚举的所有值
            string strText;
            foreach (var arr in arrs)
            {
                if (replaceChar != "") strText = Enum.Parse(type, arr.ToString()).ToString().Replace(replaceChar, " ").Trim();
                else strText = Enum.Parse(type, arr.ToString()).ToString();
                DataRow aRow = dt.NewRow();
                aRow[0] = (int)arr;
                aRow[1] = strText;
                dt.Rows.Add(aRow);
            }
            return dt;
        }
        public static ushort CRC16_CCITT(byte[] pchMsg, int wDataLen)
        {
            byte i, chChar;
            ushort wCRC = 0;
            for (int index = 0; index < wDataLen; index++)
            {
                chChar = pchMsg[index];
                wCRC ^= (ushort)(chChar << 8);
                for (i = 0; i < 8; i++)
                {
                    if ((wCRC & 0x8000) > 0)
                        wCRC = (ushort)((wCRC << 1) ^ 0x1021);
                    else
                        wCRC <<= 1;
                }
            }
            return wCRC;
        }
    }
}

